# soyoung fe cli


[![Build Status](https://travis-ci.org/soyoung616/sy-cli.svg?branch=master)](https://travis-ci.org/soyoung616/sy-cli)
[![Github Releases](https://img.shields.io/npm/v/sy-cli.svg)](https://github.com/soyoung616/sy-cli)

> 大部分子命令都需要内网环境，外网环境使用暂不支持

## 关于sy-cli
sy-cli是为了更加高效解决日常sy前端工作中的开发/调试/部署问题,包含:
  * 小程序 - 自动生成二维码，
  * 统一发布流程 接入发布系统，
  * 基础js类库引用, 
  * 跨平台调试工具, 
  * 命令行生成雪碧图,
  * 命令行qshell使用(解决跨平台兼容问题),
  * 等等 
  
sy-cli可以接入有帮助的各种,感兴趣的乡亲随时联系我~

## 安装sy-cli
````
npm install sy-cli
````

## 查看帮助及所有命令

````
sy-cli -h
````
![查看帮助及所有命令](https://upload-images.jianshu.io/upload_images/6622941-b73fe8fd73ed88b8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)


## 小程序 - 自动生成二维码

需要在打包机上安装好 微信开发者工具，配置好开发环境！才能有下面步骤！！！

````
// 在你的项目中 
// 新建 sy-cli-qr.json
// 修改package.json的scripts
````

````
// package.json

...
"scripts": {
    "dev": "wepy build --watch",
    "build": "cross-env NODE_ENV=production wepy build --no-cache",
    "test": "echo \"Error: no test specified\" && exit 1",
    "qr": "sy-cli qr \"./sy-cli-qr.json\""
  },
...
````
````
// sy-cli-qr.json

{
 "path":{
// mac上的cli路径都一样
   "cli":"/Applications/wechatwebdevtools.app/Contents/Resources/app.nw/bin/cli",
// wepy生成后的路径
   "wx":"./dist"
 },
 "source":{
// wepy的编译
   "scripts":"npm run build"
 },
// jenkins的工作空间里面
 "jenkinsURL":"http://ip:8080/job/XXX/ws/",
// 钉钉机器人的token
 "dingtalkToken":"XXXX"
}
````
ps:
jenkins的打包机器为 物理mac机器，所以不能在内部gitlab 使用webhook触发。

jenkins上的图片也不能对外解析，所以钉钉里面无法直接展示

具体原理https://www.jianshu.com/p/bbe144ac0d6a
 

## upload - 接入发布系统,统一发布流程
```
sy-cli upload  <path> (--am) (--test)
```
项目配置 对应的json 文件. 内容为下图格式
```
{
    // 项目名称
    "productName": "fe-m",
    "protocol": "http://",
    // 子项目git地址
    "url" : "*******.git",
    // git 用户名
    "userrname": "***",
    // git 密码
    "password": "***",
    // 对应path 路径
    "gitpath": "xxx"
}
```

![image.png](https://upload-images.jianshu.io/upload_images/11710116-950538ab051782e8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## utils - 在当前项目加入工具类
utils.js 引入方式为打包引用/cdn引用两种，选择后输入gitlab账户，提供最新版下载或者CDN地址
````
sy-cli utils
````
![image.png](https://upload-images.jianshu.io/upload_images/6622941-257aed05a035c2c5.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## bsync - 代理URL及监听指定目录文件，实现浏览器同步刷新
集成` browser sync`，输入要代理的URL及目录即可实现

````
sy-cli bsync
````
![image.png](https://upload-images.jianshu.io/upload_images/6622941-f0ee82b7252ca65d.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## cdn  - 目前包含qupload 上传 及 cdnrefresh 刷新CDN地址缓存两种

```js
sy-cli cdn <path>
```
sy-cli cdn <path> 会根据提供的path路径读取七牛上传配置文件， 集成了sy-qshell ，从服务器拉取最新的aksk， 实现文件上传。 



## r <option> - 有条件展示的命令
如果sy-cli执行的当前目录包含package.json，且package包含scripts，在 `sy-cli -h`的时候会在带出当前可以执行命令

```
sy-cli r test

等同于

npm run test

```

![r <option>](https://upload-images.jianshu.io/upload_images/6622941-22033de1d22eeddf.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)

## sprite - 生成精灵图及样式表
输入或默认在要生成的文件夹下，输入要生成为精灵图的图片前缀（eg : icon- ***.jpg） 会自动生成相对应的精灵图及样式表

操作流程：
- sy-cli sprite 
- 按照步骤，是否在当前目录下执行，或可输入相对当前路径的执行目录
- 将事先准备好要打包的图片的统一前缀填写
- 调节图片直接的距离（默认为0）
- 将生成出sprite的文件夹，文件夹中会出现精灵图，以及对应的样式表。


```js
sy-cli sprite
```

![image.png](https://upload-images.jianshu.io/upload_images/11710116-b160872bc0ee034e.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240)
