
const inquirer = require('inquirer')
const shell = require('shelljs')
let browserSync = require('browser-sync')

// 输入地址
function setAddress (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'input',
      name: 'address',
      message: '请输入动态资源地址'
    }).then(function (answers) {
      config.address = answers.address
      if (answers.address && answers.address.trim() !== '') {
        resolve(config)
      }
    })
  })
}

// 设置静态资源文件夹
function setDist (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'input',
      name: 'dist',
      message: '请输入静态资源所在目录'
    }).then(function (answers) {
      config.dist = answers.dist
      if (answers.dist && answers.dist.trim() !== '') {
        resolve(config)
      }
    })
  })
}

function bsyncInit (config) {
  setAddress(config).then(resolve => {
    return setDist(config)
  }).then(resolve => {
    browserSync.init({
      proxy: resolve.address
    })
    browserSync.watch(`${shell.pwd()}/${resolve.dist}/**/*`).on('change', browserSync.reload)
  })
}

module.exports = bsyncInit
