const inquirer = require('inquirer')
const shell = require('shelljs')
const sySprite = require('../utils/sy-sprite')
const path = require('path')
// 输入地址
function setAddress (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'input',
      name: 'address',
      message: '请输入要生成资源地址(相对于当前路径)'
    }).then(function (answers) {
      if (answers.address && answers.address.trim() !== '') {
        config.address = path.resolve(shell.pwd().toString(), answers.address)
        resolve(config)
      }
    })
  })
}

// 设置静态资源文件夹
function setPrefix (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'input',
      name: 'prefix',
      message: '请输入需要生成雪碧图的名称前缀'
    }).then(function (answers) {
      config.prefix = answers.prefix
      if (answers.prefix && answers.prefix.trim() !== '') {
        resolve(config)
      }
    })
  })
}

function isHere (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'list',
      name: 'flag',
      message: `是否在当前目录下执行(${shell.pwd()})`,
      choices: [{
        name: '是的',
        value: true
      }, {
        name: 'No',
        value: false
      }]
    }).then(function (answers) {
      config.flag = answers.flag
      resolve(config)
    })
  })
}
// 设置图片的padding
function setPadding (config) {
  return new Promise((resolve) => {
    inquirer.prompt({
      type: 'input',
      name: 'padding',
      message: '请输入雪碧图间隔(默认为0)'
    }).then(function (answers) {
      config.padding = answers.padding && answers.padding.trim() !== '' ? parseInt(answers.padding) : 0
      resolve(config)
    })
  })
}

function spriteInit (config) {
  if (config.filesList) {
    sySprite(config, true)
    return
  }
  isHere(config).then(resolve => {
    if (!config.flag) {
      return setAddress(config)
    } else {
      config.address = shell.pwd().toString()
    }
  }).then(resolve => {
    return setPrefix(config)
  }).then(resolve => {
    return setPadding(config)
  }).then(resolve => {
    sySprite(config)
  })
}

module.exports = spriteInit
