/**
 * 选择引入方式，提供源码下载
 */
const inquirer = require('inquirer')
const shell = require('shelljs')
let config = {
  way: null
}

function choicesWay () {
  return new Promise((resolve, reject) => {
    inquirer.prompt({
      type: 'list',
      name: 'way',
      message: '请选择引用方式',
      choices: [{
        name: 'commonJS',
        value: 'commonJS'
      }, {
        name: 'CDN',
        value: 'CDN'
      }]
    }).then(function (answers) {
      config.way = answers.way
      resolve(config)
    })
  })
}

function utils () {
  choicesWay().then(resolve => {
    if (resolve.way === 'CDN') {
      shell.exec(`npm view sy-conf version`, function (code, stdout, stderr) {
        if (code === 0) {
          console.log(`请使用\nhttps://cdn.jsdelivr.net/npm/sy-conf@${stdout}/index.js`)
        } else {
          console.log('获取 sy-conf 版本失败，请稍后重试')
        }
      })
    } else {
      console.log('依赖安装中,请稍后……')
      shell.exec(`npm install sy-conf`, function (code, stdout, stderr) {
        console.log(stdout)
        let _txt = '依赖安装'
        if (code !== 0) {
          console.log(stderr)
          _txt += '失败,请手动安装依赖'
        } else {
          _txt += '成功'
        }
        console.log(`${_txt}`)
      })
    }
  })
}

module.exports = utils
